"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = __importStar(require("react"));
class FlipOver extends React.Component {
    constructor() {
        super(...arguments);
        this.state = {
            rotation: this.props.flipped ? 180 : 0,
        };
    }
    static getDerivedStateFromProps(props, state) {
        const flipped = Boolean(props.flipped);
        const isFlipped = state.rotation % 360 === 180;
        if (isFlipped === flipped) {
            return null;
        }
        const { rotate = 'default' } = props;
        if (rotate === 'default') {
            return {
                rotation: isFlipped ? 0 : 180,
            };
        }
        else {
            return {
                rotation: state.rotation + 180,
            };
        }
    }
    render() {
        const { direction = 'horizontal', rotate = 'default', duration = 0.5, width = 'auto', height = 'auto', perspective = 5000, style = {}, children, } = this.props;
        const { rotation } = this.state;
        const front = children[0];
        const back = children[1];
        const rotateDir = direction === 'horizontal' ? 'rotateY' : 'rotateX';
        const styles = {
            width: '100%',
            height: '100%',
            position: 'absolute',
            transition: `${duration}s`,
            BackfaceVisibility: 'hidden',
            WebkitBackfaceVisibility: 'hidden',
        };
        const styleFront = {
            transform: `${rotateDir}(${rotation}deg)`,
            ...styles,
        };
        const styleBack = {
            transform: `${rotateDir}(${rotation + (rotate === 'default' ? -180 : 180)}deg)`,
            ...styles,
        };
        return (React.createElement("div", { style: {
                ...style,
                width,
                height,
                backgroundColor: 'transparent',
                perspective: `${perspective}px`,
            } },
            React.createElement("div", { style: {
                    width: '100%',
                    height: '100%',
                    position: 'relative',
                    transformStyle: 'preserve-3d',
                    backgroundColor: 'transparent',
                    transition: `${duration}s`,
                } },
                React.createElement("div", { style: styleFront }, front),
                React.createElement("div", { style: styleBack }, back))));
    }
}
exports.default = FlipOver;
